capture program drop constrained_wc
program define constrained_wc
	use `1' , clear
	sort isic
	by isic: gen t=_n
	xtset nsec t
	
	xtreg `2' `3', fe vce(robust)
	local coef=_b[`3']
	local se=_se[`3']
	
	use $outputpath\regsec_wc_`2'`3', clear
	sort isic3d
	merge isic3d using weight
	drop if _merge==2
	drop _merge
	keep isic3d wk_vaid_stan wkm_y_io 
	egen sumwk=sum(wk_vaid_stan)
	replace wk_vaid_stan=wk_vaid_stan/sumwk
	g wkmwk=wk_vaid_stan*wkm_y_io
	egen sumwkmwk=sum(wkmwk)
	g nk=wkm_y_io*wk_vaid_stan/sumwkmwk
	egen sumnk= sum(nk)
	replace nk=nk/sumnk
	g b_`3'=`coef'
	g se_`3'=`se'
	sum b_`3'
	
	g VARsigma=se_`3'*se_`3'
	g nksigmak=nk*(1-b_`3')
	g nksigmawkm=nk*(-b_`3')*wkm_y_io
	g var_elimpt_tot=(nk*(1-wkm_y_io))*(nk*(1-wkm_y_io))*VARsigma

	collapse (mean) b_`3' se_`3' (sum) wk=wk_vaid_stan nk nksigmak nksigmawkm var_elimpt_tot 
	
	g estimated_coef=b_`3'
	g se_estimated_coef=se_`3'
	g elimpt_tot=1-nksigmak+nksigmawkm
	g se_elimpt_tot=sqrt(var_elimpt_tot)
	
	label var estimated_coef "Estimated pooled microeconomic elasticity"
	label var se_estimated_coef "Estimated standard deviation of the coefficient"
	label var elimpt_tot "Aggregate trade elasticity"
	label var se_elimpt_tot "Standard deviation of the aggregate trade elasticity"
	
	keep estimated_coef se_estimated_coef  elimpt_tot se_elimpt_tot
	sum elimpt_tot
	
	save con_wc_`2'`3', replace
end
