* First-stage regression;
proc sort data=base_GS;
	by hs6;
proc glm noprint data=base_GS;
	by hs6;
	class i;
	model dls2 dlps =i /noint p  nouni;
	output out=base_GS p=s2hat pshat;
run;quit;
* base grid search;
proc sort data=base_GS;
	by &sect hs6;
proc sort data=FE_unc;
	by &sect hs6;
data base_GS;
	merge base_GS FE_unc;
	by &sect hs6;
data base_GS;
	set base_GS;
	where i^=' ';
data sectGS;
	set sectGS;
	cste=1;
data nbsectGS;
	set sectGS;
	by cste;
	if last.cste;
	call symput('nbsect',nsec);
run;
proc sort data=base_GS;
	by &sect;
proc sort data=sectGS;
	by &sect;
data base_GS;
	merge base_GS sectGS(keep=&sect nsec);
	by &sect;
run;
* create output file;
data sol_gs;
	&sect='000 ';
data sol_gs;
	set sol_gs;
	if &sect='000 ' then delete;
data scr;
	epsilon=1;
data scr;
	set scr;
	if epsilon=1 then delete;
proc sort data=base_GS;
	by nsec hs6 i;
run;
* First grid search between 0 and 30, searching for a global minimum;
%macro gridsearch;
%do sec=1 %to &nbsect;
data temp;
	set base_GS;
	if nsec^=&sec then delete;
data temp2;
	set sectGS;
	where nsec=&sec;
data scr_&sec;
	&sect='000';
data scr_&sec;
	set scr_&sec;
	if &sect='000' then delete;
%do sigma0=0 %to 5;
proc iml;
use temp;
	read all var {estimate} into x0;
	read all var {dlp2} into y;
	read all var {s2hat} into x1;
	read all var {pshat} into x2;
scr=0;
parametres={0 0 0};
sigma=5*&sigma0;
do i=1 to 500;
sigma=sigma+0.01;
epsilon=1-sigma;
do omega=0.01 to 0.99 by 0.01;
theta1=-omega/epsilon;;
theta2=omega+1/epsilon;
u=y-x0-theta1#x1-theta2#x2;
SCRi=u`*u;
nsec=&sec;
parametresi=nsec||epsilon||omega;
parametres=parametres//parametresi;
SCR=SCR//scri;
end;
end;
SCR=parametres||scr;
toto=nrow(SCR);
SCR=SCR[2:toto,];
noms='nsec'||'epsilon'||'omega'||'SCR';
create scr from scr [colname=noms];append from scr;
quit;
data scr_&sec;
	set scr_&sec scr;
	if epsilon=. then delete;
proc sort data=scr_&sec;
	by epsilon;
run;
%end;
proc sort data=scr_&sec;
	by scr;
data scr_&sec;
	set scr_&sec(obs=1);
data sol_gs;
	set sol_gs scr_&sec;
run;
proc delete data=scr_&sec;
run;
%end;
%mend gridsearch;
%gridsearch;
run;
proc sort data=sol_gs;
	by nsec;
proc sort data=sectGS;
	by nsec;
data sol_gs;
	merge sectGS(keep=&sect nsec) sol_gs(drop=&sect);
	by nsec;
run;

* bootstrap on the first set of grid searched sectors;
data sol_gs;
	set sol_gs;
	where epsilon>-30;
data sol_gs;
	set sol_gs;
	nsec=_n_;
proc sort data=sol_gs;
	by &sect;
proc sort data=base_GS;
	by &sect;
data base_GS;
	merge base_GS(drop=nsec) sol_gs(keep=&sect nsec);
	by &sect;
data base_GS;
	set base_GS;
	if nsec=. then delete;
proc sort data=sectGS;
	by &sect;
data sectGS;
	merge sectGS(drop=nsec) sol_gs(keep=&sect nsec);
	by &sect;
data sectGS;
	set sectGS;
	if nsec=. then delete;
data nbsectGS;
	set sectGS;
	by cste;
	if last.cste;
	call symput('nbsect',nsec);
run;

%macro bootstrap;
%do sec=1 %to &nbsect;
dm "out;clear;log;clear;";
data temp;
	set base_GS;
	if nsec^=&sec then delete;
data temp2;
	set sectGS;
	where nsec=&sec;
data temp3;
	set sol_gs;
	where nsec=&sec;
	call symput('omega',omega);
proc means noprint data=temp;
	var dlp2;
	output out=count N=nbobs;
data count;
	set count;
	nbobsb=round(0.99*nbobs);
	call symput ('nbobsb',nbobsb);
run;
data boot_&sec;
	&sect='000 ';
data boot_&sec;
	set boot_&sec;
	if &sect='000 ' then delete;
%do loop=0 %to 9;
dm "out;clear;log;clear;";
%let begin=&loop*100+1;
%let end=&loop*100+100;
%do nboot= &begin %to &end;
proc surveyselect noprint data=temp out=tempb method=SRS sampsize=&nbobsb rep=1;
	id nsec estimate dlp2 s2hat pshat ;
run;
data boot;
	&sect='000 ';
data boot;
	set boot;
	if &sect='000 ' then delete;
%do sigma0=0 %to 5;
proc iml;
use tempb;
	read all var {estimate} into x0;
	read all var {dlp2} into y;
	read all var {s2hat} into x1;
	read all var {pshat} into x2;
scr=0;
parametres={0 0 0 0};
sigma=5*&sigma0;
do i=1 to 500;
sigma=sigma+0.01;
epsilon=1-sigma;
omega=&omega;
theta1=-omega/epsilon;
theta2=omega+1/epsilon;
u=y-theta1#x1-theta2#x2-x0;
SCRi=u`*u;
nsec=&sec;
nboot=&nboot;
parametresi=nsec||nboot||epsilon||omega;
parametres=parametres//parametresi;
SCR=SCR//scri;
end;
SCR=parametres||scr;
toto=nrow(SCR);
SCR=SCR[2:toto,];
noms='nsec'||'nboot'||'epsilon'||'omega'||'SCR';
create scr from scr [colname=noms];append from scr;
quit;
proc sort data=scr;
	by epsilon scr;
run;
data scr;
	set scr;
	if epsilon=lag(epsilon) then delete;
run;
proc sort data=scr;
	by nsec;
proc sort data=sectGS;
	by nsec;
data scr;
	merge sectGS(keep=&sect nsec) scr;
	by nsec;
data boot;
	set boot scr;
	if epsilon=. then delete;
proc sort data=boot;
	by epsilon;
run;
%end;
proc sort data=boot;
	by scr;
data boot_&sec;
	set boot_&sec boot(obs=1);
run;
%end;
%end;
proc means noprint data=boot_&sec;
	var epsilon;
	output out=ecartype var=VARepsilon;
data ecartype;
	set ecartype;
	nsec=&sec;
proc sort data=ecartype;
	by nsec;
proc sort data=sol_gs;
	by nsec;
data sol_gs;
	merge sol_gs ecartype(keep=nsec VARepsilon);
	by nsec;
run;
proc delete data=boot_&sec;
run;
%end;
%mend bootstrap;
%bootstrap;
run;
